function [v_data] = blake256_initialization(chain_values,salt,constants,counter, num_of_blake_call)
%Ova funkcija inicijalizuje v matricu na osnovu SHA-3 proposal BLAKEdokumenta strana 9 poglavlje 2.1.2
v_data = zeros(4, 4, 'uint32');



t0 = bitand(counter,hex2dec('00000000FFFFFFFF'));
t0 = cast(t0, 'uint32');
t1 = bitand(counter,hex2dec('FFFFFFFF00000000'))/2^32;
t1 = cast(t1, 'uint32');

v_data(1,1) = chain_values(1);
v_data(1,2) = chain_values(2);
v_data(1,3) = chain_values(3);
v_data(1,4) = chain_values(4);
v_data(2,1) = chain_values(5);
v_data(2,2) = chain_values(6);
v_data(2,3) = chain_values(7);
v_data(2,4) = chain_values(8);
v_data(3,1) = bitxor(salt(1) , constants(1));
v_data(3,2) = bitxor(salt(2) , constants(2));
v_data(3,3) = bitxor(salt(3) , constants(3));
v_data(3,4) = bitxor(salt(4) , constants(4));
v_data(4,1) = bitxor(t0(num_of_blake_call) , constants(5));
v_data(4,2) = bitxor(t0(num_of_blake_call) , constants(6));
v_data(4,3) = bitxor(t1(num_of_blake_call) , constants(7));
v_data(4,4) = bitxor(t1(num_of_blake_call) , constants(8));

end

