function [checksum, status] = check_sum_generation(ip_header)
% Ova funkcija prihvata ip header duzine 20 bajtova i vraca njegovu check sumu
% Objasnjenje racunjanja uzeto sa (https://en.wikipedia.org/wiki/IPv4_header_checksum)
% Ukoliko je duzina hedera razlicita od 20 bajtova funkcija prijavljuje
% gresku

checksum = zeros(1,1,'uint32');

ip_header_local = cast(ip_header,'uint32');

if(size(ip_header,1) ~= 20)
    status = 1;
    display('Duzina IP hedera je razlicita od 20 bajtova');
    return;
else
    status = 0;
end

checksum = ip_header_local(1)*2^8 + ip_header_local(2);
checksum = checksum + ip_header_local(3)*2^8 + ip_header_local(4);
checksum = checksum + ip_header_local(5)*2^8 + ip_header_local(6);
checksum = checksum + ip_header_local(7)*2^8 + ip_header_local(8);
checksum = checksum + ip_header_local(9)*2^8 + ip_header_local(10);
checksum = checksum + ip_header_local(11)*2^8 + ip_header_local(12);
checksum = checksum + ip_header_local(13)*2^8 + ip_header_local(14);
checksum = checksum + ip_header_local(15)*2^8 + ip_header_local(16);
checksum = checksum + ip_header_local(17)*2^8 + ip_header_local(18);
checksum = checksum + ip_header_local(19)*2^8 + ip_header_local(20);
carry = bitand(checksum,hex2dec('000F0000'))/2^16;
checksum = bitand(checksum,hex2dec('0000FFFF')) + carry;
carry = bitand(checksum,hex2dec('00010000'))/2^16;
checksum = bitand(checksum,hex2dec('0000FFFF')) + carry;
checksum = bitcmp(checksum,32);

return;

end

