function [a,b,c,d] = g_fcn(a, b, c, d, round_no, fcn_no, msgblk_no, message, permutation_matrix, constants)


persistent g_temp1 g_temp2              %Keep memory space for local variables
persistent permutation1 permutation2
persistent sigma1 sigma2

%Get permutation matrix reference values
round_no = mod(round_no, 10);
round_no = round_no +1;
permutation1 = 2.*fcn_no +1;
permutation2 = 2.*fcn_no +2;

sigma1 = permutation_matrix(round_no, permutation1);
sigma2 = permutation_matrix(round_no, permutation2);

%Start the calculations:
%First a
g_temp1 = binary_add32(a,b);
g_temp2 = bitxor(message(msgblk_no, sigma1), constants(sigma2));
a = binary_add32(g_temp1, g_temp2);

%First d
g_temp1 = bitxor(d, a);
d = binary_rotrite32(g_temp1, 16);

%First c
c = binary_add32(c, d);

%First b
g_temp1 = bitxor(b, c);
b = binary_rotrite32(g_temp1, 12);

%Second a
g_temp1 = binary_add32(a,b);
g_temp2 = bitxor(message(msgblk_no, sigma2), constants(sigma1));
a = binary_add32(g_temp1, g_temp2);

%Second d
g_temp1 = bitxor(d, a);
d = binary_rotrite32(g_temp1, 8);

%Second c
c = binary_add32(c, d);

%Second b
g_temp1 = bitxor(b, c);
b = binary_rotrite32(g_temp1, 7);

end %function