clc;
clear all;

prompt = {'Unesite broj IP paketa i pritisnite OK.'};
dlg_title = 'Broj paketa';
num_lines = 1;
defaultans = {'5','hsv'};
answer = inputdlg(prompt,dlg_title,num_lines,defaultans);
number_of_ip_packets = str2double(answer);


if isempty(number_of_ip_packets)
    clear all;
    break;
end

if (rem(number_of_ip_packets,1) ~= 0 || number_of_ip_packets<1)
    errordlg('Pogresan unos!')
    clear all;
    break;
end

heder_length = 20;
hesh_length = 32;

%sacuvajmo ulazne ip pakete u fajl
fileID_in = fopen('../IO_FILES/input.txt','w');
%sacuvajmo izlazne ip pakete u fajl
fileID_out = fopen('../IO_FILES/output.txt','w');


payload_length(1:number_of_ip_packets) = ceil(1448*rand(number_of_ip_packets,1));


for ii=1:number_of_ip_packets
    clear ip_packet
    [ip_packet, status] = ip_packet_generation(payload_length(ii));
    if(status~=0)
        display('Greska u generisanju IP paketa');
        break;
    end;
    fprintf(fileID_in,'%u\n',ip_packet);
    
    %Digitalni potpis payload-a
    salt = zeros(4,1,'uint32');
    
    [hash, status] = BLAKE256(ip_packet(21:end), salt);
    
    if(status~=0)
        display('Greska pri racunanju digitalnog potpisa');
        break;
    end;
    
    %Dodavanje hash na kraju payload-a
    ip_packet = [ip_packet; hash];
    
    %Promena ukupne duzine ip poruke u ip hederu
    ip_packet(3) = bitand(payload_length(ii)+heder_length+hesh_length,hex2dec('FF00'))/2^8;
    ip_packet(4) = bitand(payload_length(ii)+heder_length+hesh_length,hex2dec('00FF'));
    
    ip_packet(11) = hex2dec('00');
    ip_packet(12) = hex2dec('00');
    
    %Racunanje nove checksume
    [checksum, status] = check_sum_generation(ip_packet(1:20));
    if(status ~= 0)
        display('Greska prilikom racunjanja check sume')
        break;
    end
    
    
    %promena check sume u hederu
    ip_packet(11) = bitand(checksum,hex2dec('0000FF00'))/2^8;
    ip_packet(12) = bitand(checksum,hex2dec('000000FF'));
    
    
    
    fprintf(fileID_out,'%u\n',ip_packet);
    
end;


%Zatvaranje reference na ulazni fajl
fclose(fileID_in);
%Zatvaranje reference na izlazni fajl
fclose(fileID_out);