LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE WORK.blake_pak.ALL;

ENTITY blake_init IS
    PORT (
        clk_in : IN STD_LOGIC; 

        h_in : IN STD_LOGIC_WIDTHx8;
        m_in : IN STD_LOGIC_WIDTHx16;
        s_in : IN STD_LOGIC_WIDTHx4;
        t_in : IN  STD_LOGIC_WIDTHx2;

        h_out : OUT STD_LOGIC_WIDTHx8;
        m_out : OUT STD_LOGIC_WIDTHx16;
        s_out : OUT STD_LOGIC_WIDTHx4;
        v_out : OUT STD_LOGIC_WIDTHx16
    );
END blake_init;

ARCHITECTURE blake_init_a OF blake_init IS

    SIGNAL h_reg : STD_LOGIC_WIDTHx8 := INIT_WIDTHx8;
    SIGNAL m_reg : STD_LOGIC_WIDTHx16 := INIT_WIDTHx16;
    SIGNAL s_reg : STD_LOGIC_WIDTHx4 := INIT_WIDTHx4;
    SIGNAL v_reg : STD_LOGIC_WIDTHx16 := INIT_WIDTHx16;

BEGIN 


    --KOD RESENAJA SA MAX BRZINOM
    --PORUKU m DA PROSLEDJUJEMO KROZ PIPELINE ZAJEDNO SA
    --PODACIMA,JER CEMO U SVAKOM STEPENU CITATI TU VREDNOST
    --I m MORA BITI REGISTROVAN
    PROCESS(clk_in)
    BEGIN
        IF (clk_in'EVENT AND clk_in = '1') THEN	
            h_reg <= h_in;
            m_reg <= m_in;
            s_reg <= s_in;
            v_reg(0)  <= h_in(0);
            v_reg(1)  <= h_in(1);
            v_reg(2)  <= h_in(2);
            v_reg(3)  <= h_in(3);
            v_reg(4)  <= h_in(4);
            v_reg(5)  <= h_in(5);
            v_reg(6)  <= h_in(6);
            v_reg(7)  <= h_in(7);
            v_reg(8)  <= s_in(0) XOR C_CON_0;
            v_reg(9)  <= s_in(1) XOR C_CON_1;
            v_reg(10) <= s_in(2) XOR C_CON_2;
            v_reg(11) <= s_in(3) XOR C_CON_3;
            v_reg(12) <= t_in(0) XOR C_CON_4;
            v_reg(13) <= t_in(0) XOR C_CON_5;
            v_reg(14) <= t_in(1) XOR C_CON_6;
            v_reg(15) <= t_in(1) XOR C_CON_7;
        END IF;
    END PROCESS;

    h_out <= h_reg;
    m_out <= m_reg;
    s_out <= s_reg;
    v_out <= v_reg;

END ARCHITECTURE;
