vcom "../RTL/PAK.vhd"
vcom "../RTL/ADDRESSABLE_SHIFT_REGISTER.vhd"
vcom "../RTL/FIFO.vhd"
vcom "../RTL/BLAKE_PIPE.vhd"
vcom "../RTL/BLAKE_PIPE_FIN.vhd"
vcom "../RTL/BLAKE_PIPE_INIT.vhd"
vcom "../RTL/BLAKE_PIPE_ROUND.vhd"
vcom "../RTL/BLAKE_PIPE_ROUND_1.vhd"
vcom "../RTL/BLAKE_PIPE_ROUND_2.vhd"
vcom "../RTL/BLAKE_PIPE_ROUND_G.vhd"
vcom "../RTL/PADDING_GENERATION.vhd"
vcom "../RTL/IP_FRAME_STORING.vhd"
vcom "../RTL/IP_FRAME_SIGNATURE.vhd"

vcom "../TB/TB_IP_FRAME_SIGNATURE.vhd"

configure wave -gridoffset 0
configure wave -gridperiod 1
configure wave -griddelta 40

#Load the design. Use required libraries.#
vsim -novopt -t 1ns -lib work work.tb_ip_frame_signature

log -r /*
add wave sim:/uut/*
#add wave sim:/uut/inst_padding_generation/*
#add wave sim:/uut/inst_ip_frame_storing/*


#Change radix to Hexadecimal#
radix hex

#Supress Numeric Std package and Arith package warnings.#
#For VHDL designs we get some warnings due to unknown values on some signals at startup#
# ** Warning: NUMERIC_STD.TO_INTEGER: metavalue detected, returning 0#
#We may also get some Arithmetic packeage warnings because of unknown values on#
#some of the signals that are used in an Arithmetic operation.#
#In order to suppress these warnings, we use following two commands#
set NumericStdNoWarnings 1
set StdArithNoWarnings 1

run 1000 us
